
open Dns

type nserver =
    Glue of Unix.inet_addr
  | Extern of name

type answer_t =
  | Data of     int * rdset_t
  | DataAny of (int * rdset_t) list
  | NoData  of  int * name   (* ttl, soa name *)
  | NxDomain of int * name   (* ttl, soa name *)
  | RFailed  of string

  | Referral of name * rrset_t * rrset_t list (* qname, ns, add and out  *)
  | Alias    of name         (* qname *)

  | Error    of int
  | Truncated
  | Lame     of name
  | Invalid  of string

val string_of_answer_t : answer_t -> string
val debug : bool ref
val dbg : string -> unit

val string_of_auth : bool -> (name * int * nserver list) -> string

val make_auth : rrset_t -> rrset_t list ->
  (name * int * nserver list)
