val cache_reset : unit -> unit
val flush_cache : Dns.name -> int * int
val save_rrsets : string -> int
val save_auths  : string -> int
val load_rrsets : string -> int
val load_auths  : string -> int

val add_rrset : Dns.rrset_t -> unit
val get_rrset : Dns.name -> Dns.rrt -> int * Dns.rdset_t

val get_follow : Dns.name -> Dns.rrt ->
  Dns.name * (int * Dns.rdset_t) list * (int * Dns.rdset_t) option

val dump_one :    Dns.name -> string * int * int
val dump_follow : Dns.name -> string * int * int
val dump_under  : Dns.name -> string * int * int
val dump_all    : unit     -> string * int * int

val purge : unit -> int * int

(*

val cache_lookup : Dns.name -> Dns.rrt -> Answer.answer_t
(** [cache_lookup n t] return a subset of [answer_t] (Data, NoData,
    NxDomain or Error) or raise [Not_found] if nothing in cache for
    this name and [rrs_t].  *)

val cache_lookup_follow : Dns.name -> Dns.rrt -> Dns.name * (int *
    Dns.rdset_t) list * Answer.answer_t
(** Same as [cache_lookup] but look for a cname and follow it if
    nothing is found *)
val cache_add : Dns.name -> Dns.rrt -> Answer.answer_t -> unit
val cache_add_nxdomain : Dns.name -> Dns.name -> int -> unit

*)

val add_auth : (Dns.name * int * Answer.nserver list) -> unit
val find_auth : Dns.name -> Dns.name * Answer.nserver list
val dump_nscache : unit -> string * int
val dump_nscache_one : Dns.name -> string
val dump_nscache_all : Dns.name -> string * int

val nspurge : unit -> int


val scache_get : Unix.inet_addr -> Dns.name -> bool*bool
(** [scache_get ip z] returns (edns_support, islame) info for server
    [ip] and zone [z] *)

val scache_add_noedns : Unix.inet_addr -> unit
(** [scache_add_noedns ip] marks server [ip] as not supporting edns *)

val add_lame : Unix.inet_addr -> Dns.name -> unit
(** [add_lame ip z] marks server [ip] as being lame for zone [z] *)

val dump_scache : unit -> string * int
val spurge : unit -> unit
