open Dns

val string_of_rdset : rdset_t -> string
(** String representation of the rdset *)

val string_of_rdset_sl : rdset_t -> string
(** Single line string representation of the rdset *)


(* string_of_rrset ? *)

val string_of_msg : msg -> string
(** Get a string representation of the DNS message *)

val short_string_of_msg : msg -> string
(** Get a short string representation of the DNS message *)

val rdset_of_string_sl : string -> rdset_t

(*val rrset_of_string : string -> rrset_t*)
val rrsets_of_string : string -> rrset_t list


val split_rrsets : string -> string -> string list
(** [ split_rrsets s sep] where s contains a list of rrsets, return a
    list of strings each containing a rrset.  Each rrset string is in
    single line format if [sep] is "", in multi line format is [sep]
    is "\n". *)
